Index: bus/cam/cam_ccb.h
===================================================================
RCS file: /cvs/src/sys/bus/cam/cam_ccb.h,v
retrieving revision 1.6
diff -u -r1.6 cam_ccb.h
--- bus/cam/cam_ccb.h	29 Dec 2003 23:30:58 -0000	1.6
+++ bus/cam/cam_ccb.h	25 Jan 2004 19:52:29 -0000
@@ -276,7 +276,7 @@
 				 * tagged operations
 				 */
 	int	mintags;
-	struct	timeval last_reset;	/* Time of last bus reset/loop init */
+	struct	timeval last_reset;  /* Uptime of last bus reset/loop init */
 };
 
 typedef enum {
@@ -512,7 +512,7 @@
 /* Path Statistics CCB */
 struct ccb_pathstats {
 	struct	ccb_hdr	ccb_h;
-	struct	timeval last_reset;	/* Time of last bus reset/loop init */
+	struct	timeval last_reset;	/* Uptime of last bus reset/loop init */
 };
 
 typedef union {
Index: bus/cam/cam_periph.c
===================================================================
RCS file: /cvs/src/sys/bus/cam/cam_periph.c,v
retrieving revision 1.6
diff -u -r1.6 cam_periph.c
--- bus/cam/cam_periph.c	10 Nov 2003 06:12:00 -0000	1.6
+++ bus/cam/cam_periph.c	25 Jan 2004 20:02:07 -0000
@@ -1071,11 +1071,8 @@
 {
 	struct timeval delta;
 	struct timeval duration_tv;
-	int s;
 
-	s = splclock();
-	microtime(&delta);
-	splx(s);
+	microuptime(&delta);
 	timevalsub(&delta, event_time);
 	duration_tv.tv_sec = duration_ms / 1000;
 	duration_tv.tv_usec = (duration_ms % 1000) * 1000;
Index: bus/cam/cam_xpt.c
===================================================================
RCS file: /cvs/src/sys/bus/cam/cam_xpt.c,v
retrieving revision 1.8
diff -u -r1.8 cam_xpt.c
--- bus/cam/cam_xpt.c	29 Dec 2003 08:37:38 -0000	1.8
+++ bus/cam/cam_xpt.c	25 Jan 2004 19:54:53 -0000
@@ -162,7 +162,7 @@
 	target_id_t	target_id;
 	u_int32_t	refcount;	
 	u_int		generation;
-	struct		timeval last_reset;
+	struct		timeval last_reset;	/* uptime of last reset */
 };
 
 /*
@@ -175,7 +175,7 @@
 	TAILQ_ENTRY(cam_eb)  links;
 	path_id_t	     path_id;
 	struct cam_sim	     *sim;
-	struct timeval	     last_reset;
+	struct timeval	     last_reset;	/* uptime of last reset */
 	u_int32_t	     flags;
 #define	CAM_EB_RUNQ_SCHEDULED	0x01
 	u_int32_t	     refcount;
@@ -4233,12 +4233,8 @@
 	bus = path->bus;
 
 	if (async_code == AC_BUS_RESET) { 
-		int s;
-
-		s = splclock();
 		/* Update our notion of when the last reset occurred */
-		microtime(&bus->last_reset);
-		splx(s);
+		microuptime(&bus->last_reset);
 	}
 
 	for (target = TAILQ_FIRST(&bus->et_entries);
@@ -4253,12 +4249,8 @@
 			continue;
 
 		if (async_code == AC_SENT_BDR) {
-			int s;
-
 			/* Update our notion of when the last reset occurred */
-			s = splclock();
-			microtime(&path->target->last_reset);
-			splx(s);
+			microuptime(&path->target->last_reset);
 		}
 
 		for (device = TAILQ_FIRST(&target->ed_entries);
Index: bus/isa/syscons_isa.c
===================================================================
RCS file: /cvs/src/sys/bus/isa/syscons_isa.c,v
retrieving revision 1.3
diff -u -r1.3 syscons_isa.c
--- bus/isa/syscons_isa.c	7 Aug 2003 21:16:46 -0000	1.3
+++ bus/isa/syscons_isa.c	26 Jan 2004 06:32:29 -0000
@@ -33,6 +33,7 @@
 #include <sys/systm.h>
 #include <sys/kernel.h>
 #include <sys/module.h>
+#include <sys/systimer.h>
 #include <sys/bus.h>
 #include <sys/cons.h>
 
@@ -219,15 +220,15 @@
 		if (acquire_timer2(TIMER_16BIT | TIMER_SQWAVE))
 			return EBUSY;
 		/* set pitch */
-		pitch = timer_freq/herz;
+		pitch = cputimer_freq/herz;
 		outb(TIMER_CNTR2, pitch);
 		outb(TIMER_CNTR2, pitch >> 8);
 		/* enable counter 2 output to speaker */
 		outb(IO_PPI, inb(IO_PPI) | 3);
 	} else {
 		/* disable counter 2 output to speaker */
-		outb(IO_PPI, inb(IO_PPI) & 0xFC);
-		release_timer2();
+		if (release_timer2() == 0)
+			outb(IO_PPI, inb(IO_PPI) & 0xFC);
 	}
 #endif /* __i386__ */
 
Index: conf/files
===================================================================
RCS file: /cvs/src/sys/conf/files,v
retrieving revision 1.43
diff -u -r1.43 files
--- conf/files	20 Jan 2004 18:41:47 -0000	1.43
+++ conf/files	25 Jan 2004 07:50:40 -0000
@@ -633,6 +633,7 @@
 kern/kern_random.c	standard
 kern/kern_resource.c	standard
 kern/kern_slaballoc.c	standard
+kern/kern_systimer.c	standard
 kern/kern_mpipe.c	standard
 kern/kern_shutdown.c	standard
 kern/kern_sig.c		standard
Index: dev/acpica/acpi_timer.c
===================================================================
RCS file: /cvs/src/sys/dev/acpica/acpi_timer.c,v
retrieving revision 1.1
diff -u -r1.1 acpi_timer.c
--- dev/acpica/acpi_timer.c	24 Sep 2003 03:32:16 -0000	1.1
+++ dev/acpica/acpi_timer.c	25 Jan 2004 01:36:43 -0000
@@ -27,6 +27,9 @@
  *	$FreeBSD: src/sys/dev/acpica/acpi_timer.c,v 1.24.2.1 2003/08/22 20:49:20 jhb Exp $
  *      $DragonFly: src/sys/dev/acpica/acpi_timer.c,v 1.1 2003/09/24 03:32:16 drhodus Exp $ 
  */
+
+#ifdef NOTDEF	/* Disabled */
+
 #include "opt_acpi.h"
 #include <sys/param.h>
 #include <sys/bus.h>
@@ -387,4 +390,6 @@
 
     return(ENXIO);		/* we never match anything */
 }
+#endif
+
 #endif
Index: dev/misc/dec/mcclock.c
===================================================================
RCS file: /cvs/src/sys/dev/misc/dec/mcclock.c,v
retrieving revision 1.3
diff -u -r1.3 mcclock.c
--- dev/misc/dec/mcclock.c	7 Aug 2003 21:16:56 -0000	1.3
+++ dev/misc/dec/mcclock.c	25 Jan 2004 19:58:43 -0000
@@ -72,11 +72,10 @@
 mcclock_get(device_t dev, time_t base, struct clocktime *ct)
 {
 	mc_todregs regs;
-	int s;
 
-	s = splclock();
+	crit_enter();
 	MC146818_GETTOD(dev, &regs)
-	splx(s);
+	crit_exit();
 
 	ct->sec = regs[MC_SEC];
 	ct->min = regs[MC_MIN];
@@ -94,11 +93,10 @@
 mcclock_set(device_t dev, struct clocktime *ct)
 {
 	mc_todregs regs;
-	int s;
 
-	s = splclock();
+	crit_enter();
 	MC146818_GETTOD(dev, &regs);
-	splx(s);
+	crit_exit();
 
 	regs[MC_SEC] = ct->sec;
 	regs[MC_MIN] = ct->min;
@@ -108,9 +106,9 @@
 	regs[MC_MONTH] = ct->mon;
 	regs[MC_YEAR] = ct->year;
 
-	s = splclock();
+	crit_enter();
 	MC146818_PUTTOD(dev, &regs);
-	splx(s);
+	crit_exit();
 }
 
 int
@@ -118,23 +116,22 @@
 {
 	int timeout = 100000000;
 	int sec;
-	int s;
 
-	s = splclock();
 	for (;;) {
+		crit_enter();
 		if (!(MCCLOCK_READ(dev, MC_REGA) & MC_REGA_UIP)) {
 			sec = MCCLOCK_READ(dev, MC_SEC);
+			crit_exit();
 			break;
 		}
-		if (--timeout == 0)
+		if (--timeout == 0) {
+			crit_exit();
 			goto fail;
+		}
 	}
-
-	splx(s);
 	*secp = sec;
 	return 0;
-
  fail:
-	splx(s);
 	return ETIMEDOUT;
 }
+
Index: dev/misc/pps/pps.c
===================================================================
RCS file: /cvs/src/sys/dev/misc/pps/pps.c,v
retrieving revision 1.5
diff -u -r1.5 pps.c
--- dev/misc/pps/pps.c	7 Aug 2003 21:16:58 -0000	1.5
+++ dev/misc/pps/pps.c	25 Jan 2004 01:32:48 -0000
@@ -183,16 +183,14 @@
 	device_t ppsdev = (device_t)arg;
 	device_t ppbus = device_get_parent(ppsdev);
 	struct pps_data *sc = DEVTOSOFTC(ppsdev);
-	struct timecounter *tc;
-	unsigned count;
+	sysclock_t count;
 
-	tc = timecounter;
-	count = timecounter->tc_get_timecount(tc);
+	count = cputimer_get_count();
 	if (!(ppb_rstr(ppbus) & nACK))
 		return;
 	if (sc->pps.ppsparam.mode & PPS_ECHOASSERT) 
 		ppb_wctr(ppbus, IRQENABLE | AUTOFEED);
-	pps_event(&sc->pps, tc, count, PPS_CAPTUREASSERT);
+	pps_event(&sc->pps, count, PPS_CAPTUREASSERT);
 	if (sc->pps.ppsparam.mode & PPS_ECHOASSERT) 
 		ppb_wctr(ppbus, IRQENABLE);
 }
Index: dev/misc/xrpu/xrpu.c
===================================================================
RCS file: /cvs/src/sys/dev/misc/xrpu/xrpu.c,v
retrieving revision 1.5
diff -u -r1.5 xrpu.c
--- dev/misc/xrpu/xrpu.c	7 Aug 2003 21:16:59 -0000	1.5
+++ dev/misc/xrpu/xrpu.c	25 Jan 2004 01:35:16 -0000
@@ -73,12 +73,16 @@
 	enum { NORMAL, TIMECOUNTER } mode;
 	vm_offset_t virbase, physbase;
 	u_int	*virbase62;
+#if 0
 	struct timecounter tc;
+#endif
 	u_int *trigger, *latch, dummy;
 	struct pps_state pps[XRPU_MAX_PPS];
 	u_int *assert[XRPU_MAX_PPS], *clear[XRPU_MAX_PPS];
 };
 
+#if 0
+
 static unsigned         
 xrpu_get_timecount(struct timecounter *tc)
 {               
@@ -117,6 +121,8 @@
 	}
 }
 
+#endif
+
 static int
 xrpu_open(dev_t dev, int flag, int mode, struct thread *td)
 {
@@ -157,6 +163,7 @@
 		return (error);
 	}
 		
+#if 0
 	if (cmd == XRPU_IOC_TIMECOUNTING) {
 		struct xrpu_timecounting *xt = (struct xrpu_timecounting *)arg;
 
@@ -194,6 +201,7 @@
 		init_timecounter(&sc->tc);
 		return (0);
 	}
+#endif
 	error = ENOTTY;
 	return (error);
 }
Index: dev/serial/sio/sio.c
===================================================================
RCS file: /cvs/src/sys/dev/serial/sio/sio.c,v
retrieving revision 1.12
diff -u -r1.12 sio.c
--- dev/serial/sio/sio.c	24 Jan 2004 08:00:45 -0000	1.12
+++ dev/serial/sio/sio.c	25 Jan 2004 08:49:44 -0000
@@ -1751,7 +1751,6 @@
 	u_char	recv_data;
 	u_char	int_ctl;
 	u_char	int_ctl_new;
-	struct	timecounter *tc;
 	u_int	count;
 
 	int_ctl = inb(com->intr_ctl_port);
@@ -1761,9 +1760,8 @@
 		if (com->pps.ppsparam.mode & PPS_CAPTUREBOTH) {
 			modem_status = inb(com->modem_status_port);
 		        if ((modem_status ^ com->last_modem_status) & MSR_DCD) {
-				tc = timecounter;
-				count = tc->tc_get_timecount(tc);
-				pps_event(&com->pps, tc, count, 
+				count = cputimer_count();
+				pps_event(&com->pps, count, 
 				    (modem_status & MSR_DCD) ? 
 				    PPS_CAPTUREASSERT : PPS_CAPTURECLEAR);
 			}
Index: dev/sound/isa/i386/pca/pcaudio.c
===================================================================
RCS file: /cvs/src/sys/dev/sound/isa/i386/pca/pcaudio.c,v
retrieving revision 1.7
diff -u -r1.7 pcaudio.c
--- dev/sound/isa/i386/pca/pcaudio.c	27 Aug 2003 06:48:15 -0000	1.7
+++ dev/sound/isa/i386/pca/pcaudio.c	24 Jan 2004 23:30:29 -0000
@@ -147,7 +147,7 @@
 static int pca_sleep = 0;
 static int pca_initialized = 0;
 
-static void pcaintr(struct clockframe *frame);
+static void pcaintr(struct intrframe *frame);
 
 static	d_open_t	pcaopen;
 static	d_close_t	pcaclose;
@@ -532,7 +532,7 @@
 
 
 static void
-pcaintr(struct clockframe *frame)
+pcaintr(struct intrframe *frame)
 {
 	if (pca_status.index < pca_status.in_use[pca_status.current]) {
 		cpu_disable_intr();
Index: dev/sound/isa/i386/spkr/spkr.c
===================================================================
RCS file: /cvs/src/sys/dev/sound/isa/i386/spkr/spkr.c,v
retrieving revision 1.8
diff -u -r1.8 spkr.c
--- dev/sound/isa/i386/spkr/spkr.c	27 Aug 2003 06:48:15 -0000	1.8
+++ dev/sound/isa/i386/spkr/spkr.c	26 Jan 2004 06:32:11 -0000
@@ -15,6 +15,7 @@
 #include <sys/uio.h>
 #include <sys/conf.h>
 #include <sys/ctype.h>
+#include <sys/systimer.h>
 #include <bus/isa/i386/isa.h>
 #include <i386/isa/timerreg.h>
 #include <machine/clock.h>
@@ -79,26 +80,22 @@
 	unsigned int thz, ticks;
 {
     unsigned int divisor;
-    int sps;
 
     if (thz <= 0)
 	return;
 
-    divisor = timer_freq / thz;
+    divisor = cputimer_freq / thz;
 
 #ifdef DEBUG
     (void) printf("tone: thz=%d ticks=%d\n", thz, ticks);
 #endif /* DEBUG */
 
     /* set timer to generate clicks at given frequency in Hertz */
-    sps = splclock();
 
     if (acquire_timer2(TIMER_SEL2 | TIMER_SQWAVE | TIMER_16BIT)) {
 	/* enter list of waiting procs ??? */
-	splx(sps);
 	return;
     }
-    splx(sps);
     clock_lock();
     outb(TIMER_CNTR2, (divisor & 0xff));	/* send lo byte */
     outb(TIMER_CNTR2, (divisor >> 8));	/* send hi byte */
@@ -115,9 +112,7 @@
     if (ticks > 0)
 	tsleep((caddr_t)&endtone, PCATCH, "spkrtn", ticks);
     outb(IO_PPI, inb(IO_PPI) & ~PPI_SPKR);
-    sps = splclock();
     release_timer2();
-    splx(sps);
 }
 
 /* rest for given number of ticks */
Index: i386/i386/elan-mmcr.c
===================================================================
RCS file: /cvs/src/sys/i386/i386/elan-mmcr.c,v
retrieving revision 1.4
diff -u -r1.4 elan-mmcr.c
--- i386/i386/elan-mmcr.c	21 Jul 2003 07:57:43 -0000	1.4
+++ i386/i386/elan-mmcr.c	25 Jan 2004 01:38:19 -0000
@@ -34,6 +34,7 @@
 
 uint16_t *elan_mmcr;
 
+#if 0
 
 static unsigned
 elan_get_timecount(struct timecounter *tc)
@@ -49,6 +50,8 @@
 	"ELAN"
 };
 
+#endif
+
 void
 init_AMD_Elan_sc520(void)
 {
@@ -74,9 +77,11 @@
 	if (bootverbose)
 		printf("sysctl machdep.i8254_freq=%d returns %d\n", new, i);
 
+#if 0
 	/* Start GP timer #2 and use it as timecounter, hz permitting */
 	elan_mmcr[0xc82 / 2] = 0xc001;
 	init_timecounter(&elan_timecounter);
+#endif
 }
 
 
Index: i386/i386/mp_clock.c
===================================================================
RCS file: /cvs/src/sys/i386/i386/mp_clock.c,v
retrieving revision 1.3
diff -u -r1.3 mp_clock.c
--- i386/i386/mp_clock.c	7 Aug 2003 21:17:22 -0000	1.3
+++ i386/i386/mp_clock.c	27 Jan 2004 06:44:52 -0000
@@ -46,6 +46,8 @@
 
 #include <bus/pci/pcivar.h>
 
+#if 0
+
 static unsigned piix_get_timecount(struct timecounter *tc);
 
 static u_int32_t piix_timecounter_address;
@@ -140,3 +142,6 @@
 static devclass_t piix_devclass;
 
 DRIVER_MODULE(piix, pci, piix_driver, piix_devclass, 0, 0);
+
+#endif
+
Index: i386/i386/mp_machdep.c
===================================================================
RCS file: /cvs/src/sys/i386/i386/mp_machdep.c,v
retrieving revision 1.20
diff -u -r1.20 mp_machdep.c
--- i386/i386/mp_machdep.c	9 Jan 2004 20:49:39 -0000	1.20
+++ i386/i386/mp_machdep.c	25 Jan 2004 08:10:14 -0000
@@ -2452,10 +2452,8 @@
 	 */
 	kmem_cpu_init();
 
-	/*
-	 * Startup helper thread(s) one per cpu.
-	 */
-	sched_thread_init();
+	sched_thread_init();	/* startup helper thread(s) one per cpu */
+	initclocks_pcpu();	/* clock interrupts (via IPIs) */
 
 	/*
 	 * The idle loop doesn't expect the BGL to be held and while
@@ -2503,6 +2501,7 @@
 }
 #endif
 
+#if 0
 static void
 forwarded_statclock(int id, int pscnt, int *astmap)
 {
@@ -2595,7 +2594,9 @@
 	}
 #endif
 }
+#endif
 
+#if 0
 void
 forward_statclock(int pscnt)
 {
@@ -2655,7 +2656,9 @@
 	if (map != 0)
 		resched_cpus(map);
 }
+#endif
 
+#if 0
 void 
 forward_hardclock(int pscnt)
 {
@@ -2739,6 +2742,7 @@
 	if (map != 0) 
 		resched_cpus(map);
 }
+#endif
 
 #endif /* BETTER_CLOCK */
 
Index: i386/include/clock.h
===================================================================
RCS file: /cvs/src/sys/i386/include/clock.h,v
retrieving revision 1.4
diff -u -r1.4 clock.h
--- i386/include/clock.h	26 Aug 2003 21:42:18 -0000	1.4
+++ i386/include/clock.h	25 Jan 2004 08:46:06 -0000
@@ -30,19 +30,12 @@
 /*
  * Driver to clock driver interface.
  */
-struct clockframe;
 
-int	acquire_timer0 (int rate,
-			    void (*function)(struct clockframe *frame));
-int	acquire_timer2 (int mode);
-int	release_timer0 (void);
-int	release_timer2 (void);
 #ifndef PC98
 int	rtcin (int val);
-#else
-int	acquire_timer1 (int mode);
-int	release_timer1 (void);
 #endif
+int	acquire_timer2 (int mode);
+int	release_timer2 (void);
 int	sysbeep (int pitch, int period);
 void	timer_restore (void);
 
Index: i386/include/cpu.h
===================================================================
RCS file: /cvs/src/sys/i386/include/cpu.h,v
retrieving revision 1.12
diff -u -r1.12 cpu.h
--- i386/include/cpu.h	21 Nov 2003 05:29:08 -0000	1.12
+++ i386/include/cpu.h	24 Jan 2004 23:36:59 -0000
@@ -59,10 +59,10 @@
 #define cpu_setstack(p, ap)		((p)->p_md.md_regs[SP] = (ap))
 
 #define	CLKF_USERMODE(framep) \
-	((ISPL((framep)->cf_cs) == SEL_UPL) || (framep->cf_eflags & PSL_VM))
+	((ISPL((framep)->if_cs) == SEL_UPL) || (framep->if_eflags & PSL_VM))
 
 #define CLKF_INTR(framep)	(mycpu->gd_intr_nesting_level > 1 || (curthread->td_flags & TDF_INTTHREAD))
-#define	CLKF_PC(framep)		((framep)->cf_eip)
+#define	CLKF_PC(framep)		((framep)->if_eip)
 
 /*
  * Preempt the current process if in interrupt from user mode,
Index: i386/include/frame.h
===================================================================
RCS file: /cvs/src/sys/i386/include/frame.h,v
retrieving revision 1.3
diff -u -r1.3 frame.h
--- i386/include/frame.h	26 Aug 2003 21:42:18 -0000	1.3
+++ i386/include/frame.h	24 Jan 2004 23:29:31 -0000
@@ -129,33 +129,6 @@
 	int	if_ss;
 };
 
-/* frame of clock (same as interrupt frame) */
-
-struct clockframe {
-	int	cf_vec;
-	int	cf_ppl;
-	int	cf_fs;
-	int	cf_es;
-	int	cf_ds;
-	int	cf_edi;
-	int	cf_esi;
-	int	cf_ebp;
-	int	:32;
-	int	cf_ebx;
-	int	cf_edx;
-	int	cf_ecx;
-	int	cf_eax;
-	int	:32;		/* for compat with trap frame - trapno */
-	int	:32;		/* for compat with trap frame - err */
-	/* below portion defined in 386 hardware */
-	int	cf_eip;
-	int	cf_cs;
-	int	cf_eflags;
-	/* below only when crossing rings (e.g. user to kernel) */
-	int	cf_esp;
-	int	cf_ss;
-};
-
 int	kdb_trap (int, int, struct trapframe *);
 extern  int (*pmath_emulate) (struct trapframe *);
 
Index: i386/isa/apic_vector.s
===================================================================
RCS file: /cvs/src/sys/i386/isa/apic_vector.s,v
retrieving revision 1.14
diff -u -r1.14 apic_vector.s
--- i386/isa/apic_vector.s	25 Sep 2003 23:49:08 -0000	1.14
+++ i386/isa/apic_vector.s	25 Jan 2004 09:05:41 -0000
@@ -484,11 +484,13 @@
 	movl	PCPU(curthread),%ebx
 	cmpl	$TDPRI_CRIT,TD_PRI(%ebx)
 	jge	1f
+	subl	$8,%esp			/* make same as interrupt frame */
 	incl	PCPU(intr_nesting_level)
 	addl	$TDPRI_CRIT,TD_PRI(%ebx)
-	call	lwkt_process_ipiq
+	call	lwkt_process_ipiq_frame
 	subl	$TDPRI_CRIT,TD_PRI(%ebx)
 	decl	PCPU(intr_nesting_level)
+	addl	$8,%esp
 	pushl	TD_CPL(%ebx)
 	MEXITCOUNT
 	jmp	doreti
@@ -525,12 +527,8 @@
 	FAST_INTR(23,fastintr23)
 	
 	/* YYY what is this garbage? */
-#define	CLKINTR_PENDING							\
-	call	clock_lock ;						\
-	movl $1,CNAME(clkintr_pending) ;				\
-	call	clock_unlock ;						\
 
-	INTR(0,intr0, CLKINTR_PENDING)
+	INTR(0,intr0,)
 	INTR(1,intr1,)
 	INTR(2,intr2,)
 	INTR(3,intr3,)
